-- 
-- FarmingTablet - ButtonActions
-- 
-- @Interface: 1.4.4.0 1.4.4RC8
-- @Author: kevink98 
-- @Date: 25.09.2017
-- @Version: 1.2.0
-- 
-- @Support: http://ls-modcompany.com
-- @mCompanyInfo: http://mcompany-info.de/
-- 

ButtonActions = {};

function ButtonActions:onActiveClickNotification()
	g_farmingTablet.allAppsClose("Tablet_notifications")
end;

function ButtonActions:onActiveClickClose()
	g_farmingTablet.closeTablet();
end;

function ButtonActions:onActiveClickSettings()
	if g_farmingTablet.button.getButtonByApp("tabletMain", "btn_Settings_General").ActivateState then
		g_farmingTablet.allAppsClose("Tablet_settings1")
	elseif g_farmingTablet.button.getButtonByApp("tabletMain", "btn_Settings_Design").ActivateState then
		g_farmingTablet.allAppsClose("Tablet_settings2")
	elseif g_farmingTablet.button.getButtonByApp("tabletMain", "btn_Settings_Apps").ActivateState then
		g_farmingTablet.allAppsClose("Tablet_settings3")
		FarmingTabletButton.getSlidebarByCategoryName("SETTINGS_PAGE3", "slideBar_settings3_r").stateWidth = FarmingTablet.getAppById[FarmingTablet.settings.activeAppChoose].settings.r;
		FarmingTabletButton.getSlidebarByCategoryName("SETTINGS_PAGE3", "slideBar_settings3_g").stateWidth = FarmingTablet.getAppById[FarmingTablet.settings.activeAppChoose].settings.g;
		FarmingTabletButton.getSlidebarByCategoryName("SETTINGS_PAGE3", "slideBar_settings3_b").stateWidth = FarmingTablet.getAppById[FarmingTablet.settings.activeAppChoose].settings.b;
		FarmingTabletButton.getSlidebarByCategoryName("SETTINGS_PAGE3", "slideBar_settings3_a").stateWidth = FarmingTablet.getAppById[FarmingTablet.settings.activeAppChoose].settings.a;
		g_farmingTablet.button.getButtonByApp("tabletMain", "btn_tick_useOwnTextColor2").ActivateState = FarmingTablet.getAppById[FarmingTablet.settings.activeAppChoose].settings.useOwnTextColor;
	else 
		g_farmingTablet.button.getButtonByApp("tabletMain", "btn_Settings_General").ActivateState = true;
		g_farmingTablet.allAppsClose("Tablet_settings1")
	end;
end;

function ButtonActions:onActiveClickbackgroundHomeLower()
	if g_farmingTablet.activeOverlay > 1 then 
		g_farmingTablet.activeOverlay = g_farmingTablet.activeOverlay - 1;
	end;
end;

function ButtonActions:onActiveClickbackgroundHomeHigher()
	if g_farmingTablet.activeOverlay < table.getn(g_farmingTablet.button.overlayByModus[FarmingTabletButton.MODUS["home"]]) then 
		g_farmingTablet.activeOverlay = g_farmingTablet.activeOverlay + 1;
	end;
end;

function ButtonActions:onActiveClickbackgroundAppLower()
	local app = FarmingTablet.getAppById[FarmingTablet.settings.activeAppChoose]
	if app ~= nil and app.backgroundActiveIndex > 1 then 
		app.setBackgroundActiveIndex(app.backgroundActiveIndex-1);
	end;
end;

function ButtonActions:onActiveClickbackgroundAppHigher()
	local app = FarmingTablet.getAppById[FarmingTablet.settings.activeAppChoose]
	if app ~= nil and app.backgroundActiveIndex < table.getn(g_farmingTablet.button.overlayByModus[FarmingTabletButton.MODUS["app"]]) then 
		app.setBackgroundActiveIndex(app.backgroundActiveIndex+1);
	end;
end;

function ButtonActions:onActiveClickchooseAppLower()
	if FarmingTablet.getAppById[FarmingTablet.settings.activeAppChoose - 1] ~= nil then	
		g_farmingTablet.settings.activeAppChoose = g_farmingTablet.settings.activeAppChoose - 1;		
		FarmingTabletButton.getSlidebarByCategoryName("SETTINGS_PAGE3", "slideBar_settings3_r").stateWidth = FarmingTablet.getAppById[FarmingTablet.settings.activeAppChoose].settings.r;
		FarmingTabletButton.getSlidebarByCategoryName("SETTINGS_PAGE3", "slideBar_settings3_g").stateWidth = FarmingTablet.getAppById[FarmingTablet.settings.activeAppChoose].settings.g;
		FarmingTabletButton.getSlidebarByCategoryName("SETTINGS_PAGE3", "slideBar_settings3_b").stateWidth = FarmingTablet.getAppById[FarmingTablet.settings.activeAppChoose].settings.b;
		FarmingTabletButton.getSlidebarByCategoryName("SETTINGS_PAGE3", "slideBar_settings3_a").stateWidth = FarmingTablet.getAppById[FarmingTablet.settings.activeAppChoose].settings.a;
		g_farmingTablet.button.getButtonByApp("tabletMain", "btn_tick_useOwnTextColor2").ActivateState = FarmingTablet.getAppById[FarmingTablet.settings.activeAppChoose].settings.useOwnTextColor;
	end;
end;

function ButtonActions:onActiveClickchooseAppHigher()
	if FarmingTablet.getAppById[FarmingTablet.settings.activeAppChoose + 1] ~= nil then	
		g_farmingTablet.settings.activeAppChoose = g_farmingTablet.settings.activeAppChoose + 1;
		FarmingTabletButton.getSlidebarByCategoryName("SETTINGS_PAGE3", "slideBar_settings3_r").stateWidth = FarmingTablet.getAppById[FarmingTablet.settings.activeAppChoose].settings.r;
		FarmingTabletButton.getSlidebarByCategoryName("SETTINGS_PAGE3", "slideBar_settings3_g").stateWidth = FarmingTablet.getAppById[FarmingTablet.settings.activeAppChoose].settings.g;
		FarmingTabletButton.getSlidebarByCategoryName("SETTINGS_PAGE3", "slideBar_settings3_b").stateWidth = FarmingTablet.getAppById[FarmingTablet.settings.activeAppChoose].settings.b;
		FarmingTabletButton.getSlidebarByCategoryName("SETTINGS_PAGE3", "slideBar_settings3_a").stateWidth = FarmingTablet.getAppById[FarmingTablet.settings.activeAppChoose].settings.a;
		g_farmingTablet.button.getButtonByApp("tabletMain", "btn_tick_useOwnTextColor2").ActivateState = FarmingTablet.getAppById[FarmingTablet.settings.activeAppChoose].settings.useOwnTextColor;
	end;
end;

function ButtonActions:onActiveClickbtn_tick_notificationsPopup(button)
	button.ActivateState = not button.ActivateState;
	g_farmingTablet.notifications.showPopup = not g_farmingTablet.notifications.showPopup;
end;

function ButtonActions:onActiveClickbtn_tick_activeAkkuUsage(button)
	button.ActivateState = not button.ActivateState;
	g_farmingTablet.settings.akkuUsage = not g_farmingTablet.settings.akkuUsage;
end;

function ButtonActions:setSettingsMenuState(button, state)
	if state == 1 then
		g_farmingTablet.allAppsClose("Tablet_settings1")
		g_farmingTablet.button.getButtonByCategoryName("SETTINGS_PAGE", "btn_Settings_General").ActivateState = true;
		g_farmingTablet.button.getButtonByCategoryName("SETTINGS_PAGE", "btn_Settings_Design").ActivateState = false;
		g_farmingTablet.button.getButtonByCategoryName("SETTINGS_PAGE", "btn_Settings_Apps").ActivateState = false;
	elseif state == 2 then
		g_farmingTablet.allAppsClose("Tablet_settings2")
		g_farmingTablet.button.getButtonByCategoryName("SETTINGS_PAGE", "btn_Settings_General").ActivateState = false;
		g_farmingTablet.button.getButtonByCategoryName("SETTINGS_PAGE", "btn_Settings_Design").ActivateState = true;
		g_farmingTablet.button.getButtonByCategoryName("SETTINGS_PAGE", "btn_Settings_Apps").ActivateState = false;
	elseif state == 3 then
		g_farmingTablet.allAppsClose("Tablet_settings3")
		g_farmingTablet.button.getButtonByCategoryName("SETTINGS_PAGE", "btn_Settings_General").ActivateState = false;
		g_farmingTablet.button.getButtonByCategoryName("SETTINGS_PAGE", "btn_Settings_Design").ActivateState = false;
		g_farmingTablet.button.getButtonByCategoryName("SETTINGS_PAGE", "btn_Settings_Apps").ActivateState = true;
		FarmingTabletButton.getSlidebarByCategoryName("SETTINGS_PAGE3", "slideBar_settings3_r").stateWidth = FarmingTablet.getAppById[FarmingTablet.settings.activeAppChoose].settings.r;
		FarmingTabletButton.getSlidebarByCategoryName("SETTINGS_PAGE3", "slideBar_settings3_g").stateWidth = FarmingTablet.getAppById[FarmingTablet.settings.activeAppChoose].settings.g;
		FarmingTabletButton.getSlidebarByCategoryName("SETTINGS_PAGE3", "slideBar_settings3_b").stateWidth = FarmingTablet.getAppById[FarmingTablet.settings.activeAppChoose].settings.b;
		FarmingTabletButton.getSlidebarByCategoryName("SETTINGS_PAGE3", "slideBar_settings3_a").stateWidth = FarmingTablet.getAppById[FarmingTablet.settings.activeAppChoose].settings.a;
		g_farmingTablet.button.getButtonByApp("tabletMain", "btn_tick_useOwnTextColor2").ActivateState = FarmingTablet.getAppById[FarmingTablet.settings.activeAppChoose].settings.useOwnTextColor;
	end;
end;

function ButtonActions:onActiveClickbtn_field_category1(button)
	button.ActivateState = not button.ActivateState;
	g_farmingTablet.button.getButtonByApp("tabletMain", "btn_field_category2").ActivateState = false;
	g_farmingTablet.button.getButtonByApp("tabletMain", "btn_field_category3").ActivateState = false;
end;

function ButtonActions:onActiveClickbtn_field_category2(button)
	button.ActivateState = not button.ActivateState;
	g_farmingTablet.button.getButtonByApp("tabletMain", "btn_field_category1").ActivateState = false;
	g_farmingTablet.button.getButtonByApp("tabletMain", "btn_field_category3").ActivateState = false;
end;

function ButtonActions:onActiveClickbtn_field_category3(button)
	button.ActivateState = not button.ActivateState;
	g_farmingTablet.button.getButtonByApp("tabletMain", "btn_field_category1").ActivateState = false;
	g_farmingTablet.button.getButtonByApp("tabletMain", "btn_field_category2").ActivateState = false;
end;

function ButtonActions:onActiveClickbtn_tick_useOwnTextColor(button)
	button.ActivateState = not button.ActivateState;
	g_farmingTablet.settings.useOwnTextColor = not g_farmingTablet.settings.useOwnTextColor;
end;

function ButtonActions:onActiveClickbtn_tick_useOwnTextColor2(button)
	button.ActivateState = not button.ActivateState;
	FarmingTablet.getAppById[FarmingTablet.settings.activeAppChoose].settings.useOwnTextColor = not FarmingTablet.getAppById[FarmingTablet.settings.activeAppChoose].settings.useOwnTextColor;
end;

function ButtonActions:onActiveClickchooseAppCategoryLower(button)
	if FarmingTablet.getAppById[FarmingTablet.settings.activeAppChoose].appCategoryDefault - 1 >= 1 then
		FarmingTablet.getAppById[FarmingTablet.settings.activeAppChoose].appCategoryDefault  = FarmingTablet.getAppById[FarmingTablet.settings.activeAppChoose].appCategoryDefault - 1;
	end;	
	FarmingTablet.reloadHomeApps();
end;

function ButtonActions:onActiveClickchooseAppCategoryHigher(button)
	if FarmingTablet.getAppById[FarmingTablet.settings.activeAppChoose].appCategoryDefault + 1 <= 3 then
		FarmingTablet.getAppById[FarmingTablet.settings.activeAppChoose].appCategoryDefault  = FarmingTablet.getAppById[FarmingTablet.settings.activeAppChoose].appCategoryDefault + 1;
	end;	
	FarmingTablet.reloadHomeApps();
end;

function ButtonActions:setSlideBarAppR(slider)
	FarmingTablet.getAppById[FarmingTablet.settings.activeAppChoose].settings.r = slider.stateWidth;
end;

function ButtonActions:setSlideBarAppG(slider)
	FarmingTablet.getAppById[FarmingTablet.settings.activeAppChoose].settings.g = slider.stateWidth;
end;

function ButtonActions:setSlideBarAppB(slider)
	FarmingTablet.getAppById[FarmingTablet.settings.activeAppChoose].settings.b = slider.stateWidth;
end;

function ButtonActions:setSlideBarAppA(slider)
	FarmingTablet.getAppById[FarmingTablet.settings.activeAppChoose].settings.a = slider.stateWidth;
end;

















