-- 
-- FarmingTablet 
-- 
-- @Interface: 1.4.4.0 1.4.4RC8
-- @Author: kevink98 
-- @Date: 25.09.2017
-- @Version: 2.3.2.0
-- 
-- @Support: http://ls-modcompany.com
-- @mCompanyInfo: http://mcompany-info.de/
-- 

FarmingTablet = {};
FarmingTablet.version = "2.3.2.0";
FarmingTablet.dir = g_currentModDirectory;
addModEventListener(FarmingTablet);
getfenv(0)["g_farmingTablet"] = FarmingTablet;
print("[FarmingTablet] load " .. tostring(FarmingTablet.version));

source(FarmingTablet.dir.."FarmingTabletButton.lua");
source(FarmingTablet.dir.."ModApp.lua");
source(FarmingTablet.dir.."FarmingTabletUtils.lua");
source(FarmingTablet.dir.."FarmingTabletStartEvent.lua");
source(FarmingTablet.dir.."appStore/Appstore.lua");

function FarmingTablet:loadMap()
	FarmingTablet.getAppById = {};
	FarmingTablet.apps = {};
	FarmingTablet.installedApps = 0;
	FarmingTablet.supportedNumApps = 27;
	FarmingTablet.posDebug = false;
	
	FarmingTablet.apps_positions = {};
	FarmingTablet.apps_positions[1] = {
	{0.151,0.64,0.06525,0.116},
	{0.231,0.64,0.06525,0.116},
	{0.311,0.64,0.06525,0.116},
	{0.151,0.5,0.06525,0.116},
	{0.231,0.5,0.06525,0.116},
	{0.311,0.5,0.06525,0.116},
	};
	FarmingTablet.apps_positions[2] = {
	{0.41,0.64,0.06525,0.116},
	{0.49,0.64,0.06525,0.116},
	{0.57,0.64,0.06525,0.116},
	{0.41,0.5,0.06525,0.116},
	{0.49,0.5,0.06525,0.116},
	{0.57,0.5,0.06525,0.116},
	};
	FarmingTablet.apps_positions[3] = {
	{0.66,0.64,0.06525,0.116},
	{0.74,0.64,0.06525,0.116},
	{0.82,0.64,0.06525,0.116},
	{0.66,0.5,0.06525,0.116},
	{0.74,0.5,0.06525,0.116},
	{0.82,0.5,0.06525,0.116},
	};
	
	FarmingTablet.apps_posUsed = {};
	for i=1,3 do
		FarmingTablet.apps_posUsed[i] = {};
		for j=1,(FarmingTablet.supportedNumApps/3) do
			FarmingTablet.apps_posUsed[i][j] = false;
		end;
	end;
	FarmingTablet.apps_toDraw = {};
	
	FarmingTablet.isServer = g_server ~= nil;
	FarmingTablet.isClient = g_client ~= nil;

	if FarmingTablet.isServer and FarmingTablet.isClient then
		FarmingTablet.isClient = FarmingTablet.isClient and not g_currentMission.connectedToDedicatedServer;
	end;
	
	FarmingTablet.utils.loadLanguageText("tabletMain", FarmingTablet.dir.."languageXML_Tablet.xml");	

	FarmingTablet.showTablet = false;
	FarmingTablet.akkuFuel = 7200;
	FarmingTablet.akkuFuelCapacity = 7200;
	FarmingTablet.isLoading = false;
	FarmingTablet.serverName = "";
	FarmingTablet.timeToSaveClient = 500;
	FarmingTablet.timerToSaveClient = 300;
	FarmingTablet.loadStart = false;
	FarmingTablet.isInLoadingStation = false;	
	FarmingTablet.activeOverlay = 1;
	FarmingTablet.activeAppName = "";
	FarmingTablet.updateMs = 0;
	
	FarmingTablet.categorys = {};
	FarmingTablet.categorys[1] = FarmingTablet.utils.getTextByAppName("tabletMain", "header01");
	FarmingTablet.categorys[2] = FarmingTablet.utils.getTextByAppName("tabletMain", "header02");
	FarmingTablet.categorys[3] = FarmingTablet.utils.getTextByAppName("tabletMain", "header03");
	
	FarmingTablet.getWindowCategory = {};
	FarmingTablet.activateCategory = {};
	FarmingTablet.windows = {};
	FarmingTablet.saveApps = {};
	FarmingTablet.saveClientsApps = {};
	FarmingTablet.loadApps = {};
	FarmingTablet.loadClientsApps = {};
	FarmingTablet.apps_useSettings = {};
	
	FarmingTablet.utils.addNew_Category_Window(self, "tabletMain", "Tablet_home", "START_PAGE", true,true,true)
	FarmingTablet.utils.addNew_Category_Window(self, "tabletMain", "Tablet_settings", "SETTINGS_PAGE", true,true,true)
	FarmingTablet.utils.addNew_Category_Window(self, "tabletMain", "Tablet_settings1", "SETTINGS_PAGE1", true,true,true, "Tablet_settings")
	FarmingTablet.utils.addNew_Category_Window(self, "tabletMain", "Tablet_settings2", "SETTINGS_PAGE2", true,true,true, "Tablet_settings")
	FarmingTablet.utils.addNew_Category_Window(self, "tabletMain", "Tablet_settings3", "SETTINGS_PAGE3", true,true,true, "Tablet_settings")
	FarmingTablet.utils.addNew_Category_Window(self, "tabletMain", "Tablet_notifications", "NOTTIFICATIONS_PAGE", true,true,true)	
	
	FarmingTablet.notifications = {};
	FarmingTablet.notifications.getNotificationById = {};
	FarmingTablet.notifications.popup_timeToShow = 150;
	FarmingTablet.notifications.popup_timer = 0;
	FarmingTablet.notifications.showPopup = true;
	FarmingTablet.notifications.showPopupNow = false;
	FarmingTablet.notifications.notifications = {};	
	FarmingTablet.notifications.notificationsNoAkku = {};	
	
	FarmingTablet.utils.loadOverlay("tabletMain", FarmingTablet.dir , "overlays.xml")
	FarmingTablet.utils.loadButtons("tabletMain", FarmingTablet.dir .. "buttons.xml", self)
	
	FarmingTablet.settings = {};
	FarmingTablet.settings.activeAppChoose = 1;	
	FarmingTablet.settings.menuState = 1;
	FarmingTablet.settings.useOwnTextColor = false;
	FarmingTablet.settings.akkuUsage = true;
	
	FarmingTablet.openApp = {};
	FarmingTablet.openWindow = {};
	FarmingTablet.openTabletWindow = false;
	
	local saveApp = function(...) return FarmingTablet:saveMapApp(...) end;
	local loadApp = function(...) return FarmingTablet:loadMapApp(...) end;
	FarmingTablet:saveClientApp(saveApp); 
	FarmingTablet:loadClientApp(loadApp); 
	
	FarmingTablet.windows["Tablet_home"].active = true;
end;

function FarmingTablet.setGuiClose(old)
	return function(e, name)
		if FarmingTablet ~= nil and FarmingTablet.closeWithESC and name == "InGameMenu" then
			FarmingTablet.closeWithESC = false;
		else
			return old(e, name)
		end;
	end;
end;

function FarmingTablet:update(dt)
	if g_currentMission.controlledVehicle == nil then
		if InputBinding.isPressed(InputBinding.FTopen1) and g_gui.currentGui == nil and not FarmingTablet.showTablet then
			if InputBinding.isPressed(InputBinding.FTopen2) then
				FarmingTablet:openTablet();
			end;
		end;		
		if InputBinding.isPressed(InputBinding.MENU) and FarmingTablet.showTablet then
			FarmingTablet.closeWithESC = true;
			FarmingTablet:closeTablet();
		end;
		if InputBinding.isPressed(InputBinding.FTclose1) and FarmingTablet.showTablet then
			if InputBinding.isPressed(InputBinding.FTclose2) then
				FarmingTablet:closeTablet();
			end;
		end;	
		--if FarmingTablet.closeWithESC and g_gui.currentGuiName == "InGameMenu" then
		--if (FarmingTablet.closeWithESC) or (g_gui.currentGuiName == "InGameMenu" and FarmingTablet.showTablet) then
			--FarmingTablet.closeWithESC = false;
			--FarmingTablet:closeTablet();
			--g_gui:showGui();
			--if g_gui.currentGui~= nil then
			--	g_gui.currentGui:onClose();
			--end;
			--g_gui.currentGui = nil;
			--g_gui.currentGuiName = nil;			
		--end;
	end;
	
	if g_currentMission.environment.currentHour < 10 then
		FarmingTablet.settings.uhr1 = tostring("0"..g_currentMission.environment.currentHour);
	else
		FarmingTablet.settings.uhr1 = tostring(g_currentMission.environment.currentHour);
	end;
	if g_currentMission.environment.currentMinute < 10 then
		FarmingTablet.settings.uhr2 = tostring("0"..g_currentMission.environment.currentMinute);
	else
		FarmingTablet.settings.uhr2 = tostring(g_currentMission.environment.currentMinute);
	end;	
	
	for windowName,_ in pairs(FarmingTablet.windows) do
		if FarmingTablet.windows[windowName] and FarmingTablet.windows[windowName].active then
			if FarmingTablet.openWindow[windowName] ~= nil and not FarmingTablet.openTabletWindow then
				FarmingTablet.openWindow[windowName]();
				FarmingTablet.openTabletWindow = true;
			end;				
			FarmingTablet.windows[windowName].doUpdate();
		end;
	end;	
	
	self.updateMs = self.updateMs + dt;
	if self.updateMs >= 1000 then
		self.updateMs = self.updateMs - 1000;
		if FarmingTablet.isLoading then
			FarmingTablet.akkuFuel = FarmingTablet.akkuFuel + 240;
			if FarmingTablet.akkuFuel > 7200 then
				FarmingTablet.akkuFuel = 7200;
			end;
		elseif FarmingTablet.showTablet and FarmingTablet.settings.akkuUsage then
			FarmingTablet.akkuFuel = FarmingTablet.akkuFuel - 1;
			if FarmingTablet.akkuFuel <= 0 then
				FarmingTablet.akkuFuel = 0 
				FarmingTablet:closeTablet();
			end;
		elseif FarmingTablet.notifications.showPopupNow and FarmingTablet.akkuFuel > 0 and FarmingTablet.settings.akkuUsage then
			FarmingTablet.akkuFuel = FarmingTablet.akkuFuel - 0.5;
			if FarmingTablet.akkuFuel <= 0 then
				FarmingTablet.akkuFuel = 0 
			end;
		end;			
	end;
	
	if FarmingTablet.firstRun == nil then
		if g_server == nil and g_client ~= nil then
			g_client:getServerConnection():sendEvent(FarmingTablet_Start_ClientToServer:new());
		else
			self:loadMapXML();
		end;
		FarmingTablet.firstRun = false;
	end;
	if g_server == nil and g_client ~= nil then
		if FarmingTablet.timerToSaveClient >= FarmingTablet.timeToSaveClient then
			if not FarmingTablet.loadStart then
				self:loadMapXML();	
				FarmingTablet.loadStart = true;
			end;
			self:saveMapXML();
			FarmingTablet.timerToSaveClient = 0;
		else
			FarmingTablet.timerToSaveClient = FarmingTablet.timerToSaveClient + 1;
		end;
	end;
	if FarmingTablet.showTablet then		
		InputBinding.setShowMouseCursor(true);
	end;
end;

function FarmingTablet:setServerName(name)
	FarmingTablet.serverName = name;
end;

function FarmingTablet:openTablet() 
	if FarmingTablet.isInLoadingStation then
		FarmingTablet.addNotificationNoAkku(FarmingTablet.utils.getTextByAppName("tabletMain", "noTablet_header"), FarmingTablet.utils.getTextByAppName("tabletMain", "noTablet_line1"), FarmingTablet.utils.getTextByAppName("tabletMain", "noTablet_line2"), nil, false);	
	elseif FarmingTablet.akkuFuel <= 0 then	
		FarmingTablet.addNotificationNoAkku(FarmingTablet.utils.getTextByAppName("tabletMain", "akkuEmpty_header"), FarmingTablet.utils.getTextByAppName("tabletMain", "akkuEmpty_line1"), FarmingTablet.utils.getTextByAppName("tabletMain", "akkuEmpty_line2"), nil, false);	
	else
		FarmingTablet.showHelpText = g_currentMission.showHelpText;
		FarmingTablet.isPlayerFrozen = g_currentMission.isPlayerFrozen;
		FarmingTablet.renderTime = g_currentMission.renderTime;
		FarmingTablet.showVehicleSchema = g_currentMission.showVehicleSchema;
		FarmingTablet.ingameMap = g_currentMission.ingameMap.isVisible;
		FarmingTablet.showHudEnv = g_currentMission.showHudEnv;
		FarmingTablet.showWeatherForecast = g_currentMission.showWeatherForecast;
		if g_gui.currentGui ~= nil  then
			g_currentMission.showHelpText = FarmingTablet.showHelpText;
			g_currentMission.isPlayerFrozen = FarmingTablet.isPlayerFrozen;
			g_currentMission.renderTime = FarmingTablet.renderTime;
			g_currentMission.showVehicleSchema = FarmingTablet.showVehicleSchema;
			g_currentMission.ingameMap.isVisible = FarmingTablet.ingameMap;
			g_currentMission.showHudEnv = FarmingTablet.showHudEnv;
			g_currentMission.showWeatherForecast = FarmingTablet.showWeatherForecast;
			InputBinding.setShowMouseCursor(false);
			FarmingTablet.showTablet = false;
			g_gui.currentGui = nil;
		end;
		g_currentMission.showHelpText = false;
		g_currentMission.renderTime = false;
		g_currentMission.showVehicleSchema = false;
		g_currentMission.ingameMap.isVisible = false;
		g_currentMission.showHudEnv = false;
		g_currentMission.showWeatherForecast = false; 
		g_currentMission.isPlayerFrozen = true;
		g_gui.currentGui = FarmingTablet;
		InputBinding.setShowMouseCursor(true);
		FarmingTablet.showTablet = true;
	end;
end;

function FarmingTablet:closeTablet() 
	g_currentMission.showHelpText = FarmingTablet.showHelpText;
	g_currentMission.isPlayerFrozen = FarmingTablet.isPlayerFrozen;
	g_currentMission.renderTime = FarmingTablet.renderTime;
	g_currentMission.showVehicleSchema = FarmingTablet.showVehicleSchema;
	g_currentMission.ingameMap.isVisible = FarmingTablet.ingameMap;
	g_currentMission.showHudEnv = FarmingTablet.showHudEnv;
	g_currentMission.showWeatherForecast = FarmingTablet.showWeatherForecast;
	InputBinding.setShowMouseCursor(false);
	FarmingTablet.showTablet = false;
	FarmingTablet.notifications.showPopupNow = false;
	FarmingTablet.openTabletWindow = false;
	g_gui.currentGui = nil;
end;

function FarmingTablet:getStateTablet()
	return FarmingTablet.showTablet;
end;

function FarmingTablet.getAkkuState()
	return FarmingTablet.akkuFuel, FarmingTablet.akkuFuelCapacity;
end;

function FarmingTablet.setLoading(state)
	FarmingTablet.isLoading = state;
	if FarmingTablet.isLoading then
		local update = function(...) return FarmingTablet:updateAkkuLine(...) end;
		FarmingTablet.loadingId = FarmingTablet.addNotificationNoAkku(FarmingTablet.utils.getTextByAppName("tabletMain", "loading_header"), "", "", 0, true, update);	
	else
		for k, n in pairs(FarmingTablet.notifications.notificationsNoAkku) do
			if n.id == FarmingTablet.loadingId then
				table.remove(FarmingTablet.notifications.notificationsNoAkku, k);
				break;
			end;
		end;
	end;
end;

function FarmingTablet.setLoadingStation(state)
	FarmingTablet.isInLoadingStation = state;
end;

function FarmingTablet:updateAkkuLine(notification)
	notification.line1 = FarmingTablet.utils.getTextByAppName("tabletMain", "loading_status") .. string.format("%.f %%", (FarmingTablet.akkuFuel / 7200 * 100))
end;

function FarmingTablet.addAppToOpen(func, startWindow)
	if func ~= nil and startWindow ~= nil then
		FarmingTablet.openApp[startWindow] = func;
	end;
end;

function FarmingTablet.addAppToOpenWindow(func, window)
	if func ~= nil and window ~= nil then
		FarmingTablet.openWindow[window] = func;
	end;
end;

function FarmingTablet:saveApp(func)
	FarmingTablet.saveApps[table.getn(FarmingTablet.saveApps)+1] = func;
end;

function FarmingTablet:saveClientApp(func)
	FarmingTablet.saveClientsApps[table.getn(FarmingTablet.saveClientsApps)+1] = func;
end;

function FarmingTablet:loadApp(func)
	FarmingTablet.loadApps[table.getn(FarmingTablet.loadApps)+1] = func;
end;

function FarmingTablet:loadClientApp(func)
	FarmingTablet.loadClientsApps[table.getn(FarmingTablet.loadClientsApps)+1] = func;
end;

function FarmingTablet:saveMapXML()
	if g_server ~= nil then 		-- is Dedi or SP
		local savegameIndex = g_currentMission.missionInfo.savegameIndex;
		local savegameFolderPath = g_currentMission.missionInfo.savegameDirectory;
		if savegameFolderPath == nil then
			savegameFolderPath = ('%ssavegame%d'):format(getUserProfileAppPath(), savegameIndex);
		end;
		if fileExists(savegameFolderPath .. '/careerSavegame.xml') then
			local xml = loadXMLFile("careerSavegame", savegameFolderPath .. '/careerSavegame.xml',"careerSavegame");
			local key = "careerSavegame.FarmingTablet";
			for k,_ in pairs (FarmingTablet.saveApps) do
				FarmingTablet.saveApps[k](xml, key);
			end;
			if g_client ~= nil then
				for k,_ in pairs (FarmingTablet.saveClientsApps) do
					FarmingTablet.saveClientsApps[k](xml, key);
				end;
			end;
		
			saveXMLFile(xml);
			delete(xml);
		end;
	else							-- is Client in MP Game
		if fileExists(Utils.getFilename("FarmingTablet.xml", getUserProfileAppPath())) then
			local xml = loadXMLFile("FarmingTablet", Utils.getFilename("FarmingTablet.xml", getUserProfileAppPath()),"FarmingTablet");
			local key = "FarmingTablet";
			local i = 0;
			local save = false;
			while true do
				local k = key .. string.format(".server(%d)", i);
				if not hasXMLProperty(xml, k) then
					break;
				end;
				if getXMLString(xml, k .. "#name") == FarmingTablet.serverName then
					for p,_ in pairs (FarmingTablet.saveClientsApps) do
						FarmingTablet.saveClientsApps[p](xml, k);
					end;
					saveXMLFile(xml);
					delete(xml);
					save = true;
					break;
				end;
				i = i + 1;
			end;	
			if not save then
				local k = key .. string.format(".server(%d)", i+1);
				setXMLString(xml, k .. "#name", FarmingTablet.serverName);
				for p,_ in pairs (FarmingTablet.saveClientsApps) do
					FarmingTablet.saveClientsApps[p](xml, k);
				end;
				saveXMLFile(xml);
				delete(xml);
			end;
		else
			local xml = createXMLFile("FarmingTablet", Utils.getFilename("FarmingTablet.xml", getUserProfileAppPath()), "FarmingTablet");
			local key = "FarmingTablet";
			local k = key .. string.format(".server(%d)", 0)
			setXMLString(xml, k .. "#name", FarmingTablet.serverName);
			for p,_ in pairs (FarmingTablet.saveClientsApps) do
				FarmingTablet.saveClientsApps[p](xml, k);
			end;		
			saveXMLFile(xml);
			delete(xml);
		end;
	end;
end;

function FarmingTablet:loadMapXML()
	if g_server ~= nil then 		-- is Dedi or SP
		local savegameIndex = g_currentMission.missionInfo.savegameIndex;
		local savegameFolderPath = g_currentMission.missionInfo.savegameDirectory;
		if savegameFolderPath == nil then
			savegameFolderPath = ('%ssavegame%d'):format(getUserProfileAppPath(), savegameIndex);
		end;
		if fileExists(savegameFolderPath .. '/careerSavegame.xml') then
			local xml = loadXMLFile("careerSavegame", savegameFolderPath .. '/careerSavegame.xml',"careerSavegame");
			local key = "careerSavegame.FarmingTablet";
			if hasXMLProperty(xml, "careerSavegame.FarmingTablet") then
				for k,_ in pairs (FarmingTablet.loadApps) do
					FarmingTablet.loadApps[k](xml, key);
				end;
				if g_client ~= nil then
					for k,_ in pairs (FarmingTablet.loadClientsApps) do
						FarmingTablet.loadClientsApps[k](xml, key);
					end;
				end;			
				delete(xml);
			end;
		end;
	else							-- is Client in MP Game
		local clientXML = Utils.getFilename("FarmingTablet.xml", getUserProfileAppPath());
		if fileExists(clientXML)then
			local xml = loadXMLFile("FarmingTablet", clientXML ,"FarmingTablet");
			local key = "FarmingTablet";
			local i = 0;
			while true do
				local k = key .. string.format(".server(%d)", i)
				if not hasXMLProperty(xml, k) then
					break;
				end;
				if getXMLString(xml, k .. "#name") == FarmingTablet.serverName then
					for p,_ in pairs (FarmingTablet.loadClientsApps) do
						FarmingTablet.loadClientsApps[p](xml, k);
					end;				
					break;
				end;
				i = i + 1;
			end;
			delete(xml);
		end;
	end;
end;

function FarmingTablet:saveMapApp(xml, key)
	setXMLInt(xml, key .. ".akkuFuel", FarmingTablet.akkuFuel);
	setXMLInt(xml, key .. "#activeOverlay", FarmingTablet.activeOverlay);
	setXMLBool(xml, key .. "#showPopup", FarmingTablet.notifications.showPopup);
	setXMLBool(xml, key .. "#useOwnTextColor", FarmingTablet.settings.useOwnTextColor);
	setXMLFloat(xml, key .. ".settings" .. "#r", FarmingTabletButton.getSlidebarByCategoryName("SETTINGS_PAGE2", "slideBar_settings_r").stateWidth);
	setXMLFloat(xml, key .. ".settings" .. "#g", FarmingTabletButton.getSlidebarByCategoryName("SETTINGS_PAGE2", "slideBar_settings_g").stateWidth);
	setXMLFloat(xml, key .. ".settings" .. "#b", FarmingTabletButton.getSlidebarByCategoryName("SETTINGS_PAGE2", "slideBar_settings_b").stateWidth);
	setXMLFloat(xml, key .. ".settings" .. "#a", FarmingTabletButton.getSlidebarByCategoryName("SETTINGS_PAGE2", "slideBar_settings_a").stateWidth);
	setXMLBool(xml, key .. "#akkuUsage", FarmingTablet.settings.akkuUsage);
end;

function FarmingTablet:loadMapApp(xml, key)
	FarmingTablet.akkuFuel = getXMLInt(xml, key .. ".akkuFuel");
	FarmingTablet.activeOverlay = getXMLInt(xml, key .. "#activeOverlay");
	FarmingTablet.notifications.showPopup = getXMLBool(xml, key .. "#showPopup");
	FarmingTablet.settings.useOwnTextColor = Utils.getNoNil(getXMLBool(xml, key .. "#useOwnTextColor"), false);
	FarmingTabletButton.getSlidebarByCategoryName("SETTINGS_PAGE2", "slideBar_settings_r").stateWidth = Utils.getNoNil(getXMLFloat(xml, key .. ".settings" .. "#r"),0);
	FarmingTabletButton.getSlidebarByCategoryName("SETTINGS_PAGE2", "slideBar_settings_g").stateWidth = Utils.getNoNil(getXMLFloat(xml, key .. ".settings" .. "#g"),0);
	FarmingTabletButton.getSlidebarByCategoryName("SETTINGS_PAGE2", "slideBar_settings_b").stateWidth = Utils.getNoNil(getXMLFloat(xml, key .. ".settings" .. "#b"),0);
	FarmingTabletButton.getSlidebarByCategoryName("SETTINGS_PAGE2", "slideBar_settings_a").stateWidth = Utils.getNoNil(getXMLFloat(xml, key .. ".settings" .. "#a"),1);
	FarmingTablet.settings.akkuUsage = Utils.getNoNil(getXMLBool(xml, key .. "#akkuUsage"), true);
	
	FarmingTablet.button.getButtonByApp("tabletMain", "btn_tick_notificationsPopup").ActivateState = FarmingTablet.notifications.showPopup;	
	FarmingTablet.button.getButtonByApp("tabletMain", "btn_tick_activeAkkuUsage").ActivateState = FarmingTablet.settings.akkuUsage;	
	FarmingTablet.button.getButtonByApp("tabletMain", "btn_tick_useOwnTextColor").ActivateState = FarmingTablet.settings.useOwnTextColor;	

	if FarmingTablet.akkuFuel > 7200 then
		FarmingTablet.akkuFuel = 7200;
	end;
end;

function FarmingTablet.newWindow(nameApp, name,category,showDetails,isClick,isHover)
	FarmingTablet.windows[name] = {};
	FarmingTablet.windows[name].active = false;
	if isClick == nil then
		isClick = true;
	end;
	if isHover == nil then
		isHover = true;
	end;
	if nameApp ~= "tabletMain" then
		if FarmingTablet.apps[nameApp].useBackgroundsByTablet then
			FarmingTablet.windows[name].useBackgroundsByTablet = true;
			FarmingTablet.windows[name].id = FarmingTablet.apps[nameApp].id;
		end;
	end;
	FarmingTablet.windows[name].isClick = isClick;
	FarmingTablet.windows[name].isHover = isHover;
	FarmingTablet.windows[name].showDetails = showDetails or false;
	FarmingTablet.getWindowCategory[name] = category;
end;

function FarmingTablet.setWindow(name,value)
	FarmingTablet.windows[name].active = value;	
	if FarmingTablet.openWindow[name] ~= nil then
		FarmingTablet.openWindow[name]();
	end;
end;

function FarmingTablet:getNumActiveWindows()
	local i = 0;
	for _, w in pairs(FarmingTablet.windows) do
		if w.active then
			i = i + 1;
		end;
	end;
	return i;
end;

function FarmingTablet.setFuncWindows(name,funcUpdate,funcDraw,funcKeyEvent, drawFirst)
	FarmingTablet.windows[name].doUpdate = funcUpdate;
	FarmingTablet.windows[name].doDraw = funcDraw;
	FarmingTablet.windows[name].drawFirst = drawFirst;
	FarmingTablet.windows[name].doKeyEvent = funcKeyEvent;
end;

function FarmingTablet.addAppToHome(category,name)
	local i = 1;
	while true do
		if not FarmingTablet.apps_posUsed[category][i] then
			FarmingTablet.apps[name].posUsed = i;
			FarmingTablet.apps_toDraw[name] = FarmingTablet.apps[name];
			FarmingTablet.apps_posUsed[category][i] = true;
			break
		end;
		i = i + 1;
	end;
end;

function FarmingTablet.reloadHomeApps()
	FarmingTablet.apps_posUsed = {};
	FarmingTablet.apps_toDraw = {};
	for i=1,3 do
		FarmingTablet.apps_posUsed[i] = {};
		for j=1,(FarmingTablet.supportedNumApps/3) do
			FarmingTablet.apps_posUsed[i][j] = false;
		end;
	end;
	g_farmingTablet.addAppToHome(g_farmingTablet.apps["appStore"].appCategoryDefault,"appStore");	
	for name, app in pairs (g_farmingTablet.apps) do
		if name ~= "appStore" and app.isBought then
			g_farmingTablet.addAppToHome(app.appCategoryDefault,name)
		end;
	end;
end;

function FarmingTablet:addActiveCategories(c)
	table.insert(FarmingTablet.activateCategory, c);
end;

function FarmingTablet:mouseEvent(posX, posY, isDown, isUp, button)	
	if FarmingTablet.showTablet then
		if posX > 0.47 and posX < 0.53 and posY > 0.04 and posY < 0.115 and button == 1 and isDown then
			FarmingTablet.allAppsClose("Tablet_home");
		end;
		for windowName,_ in pairs(FarmingTablet.windows) do
			if FarmingTablet.windows[windowName] and FarmingTablet.windows[windowName].active then
				local category = FarmingTablet.getWindowCategory[windowName]
				if FarmingTablet.windows[windowName].isClick and isDown then
					local click = FarmingTabletButton:checkClickByCategory(category,posX,posY,button,isDown);
					if click then
						break;
					end;
				else 
					if FarmingTablet.windows[windowName].isHover then
						FarmingTabletButton:checkHoverByCategory(category,posX,posY);
					end;
				end;
				if FarmingTablet.windows[windowName].isClick then
					FarmingTabletButton:checkSlideBarByCategory(category,posX,posY,button,isDown,isUp);	
				end;
			end;
		end;
		for _, name in pairs(FarmingTablet.activateCategory) do
			if button == 1 then
				FarmingTabletButton:checkClickByCategory(name,posX,posY,button,isDown);
			else
				FarmingTabletButton:checkHoverByCategory(name,posX,posY);
			end;
		end;
		
		if FarmingTablet.windows["Tablet_home"].active then
			for name,_ in pairs(FarmingTablet.apps_toDraw) do
				local category = FarmingTablet.apps[name].appCategoryDefault;
				local place = FarmingTablet.apps[name].posUsed;
				local positions = {};
				positions.xL = FarmingTablet.apps_positions[category][place][1]
				positions.xR = FarmingTablet.apps_positions[category][place][1] + FarmingTablet.apps_positions[category][place][3]
				positions.yU = FarmingTablet.apps_positions[category][place][2]
				positions.yO = FarmingTablet.apps_positions[category][place][2] + FarmingTablet.apps_positions[category][place][4]
				FarmingTabletButton:checkAppClick(posX,posY,button,isDown,positions,FarmingTablet.apps[name].startWindow,name)
			end;
		end;		
		FarmingTablet.activateCategory = {};
		
		if FarmingTablet.posDebug then
			print(posX.." "..posY);
		end;	
	end;	
end;

function FarmingTablet:keyEvent(unicode, sym, modifier, isDown)
	if FarmingTablet.showTablet then
		for windowName,_ in pairs(FarmingTablet.windows) do
			if FarmingTablet.windows[windowName] and FarmingTablet.windows[windowName].active then
				if FarmingTablet.windows[windowName].doKeyEvent ~= nil then			
					FarmingTablet.windows[windowName].doKeyEvent(unicode, sym, modifier, isDown);
				end;
			end;
		end;
	end;
end;

function FarmingTablet:draw() 
	if FarmingTablet.showTablet then
		local showDetails = false;
		for windowName,_ in pairs(FarmingTablet.windows) do
			if FarmingTablet.windows[windowName] and FarmingTablet.windows[windowName].active and not FarmingTablet.windows[windowName].drawed then
				if FarmingTablet.windows[windowName].useBackgroundsByTablet then
					local app = FarmingTablet.getAppById[FarmingTablet.windows[windowName].id];					
					renderOverlay(FarmingTablet.button.getOverlayByModus_Id("app", app.backgroundActiveIndex).id,0.008,0.0163,1,0.964);
				end;
				if FarmingTablet.windows[windowName].drawFirst ~= nil then
					if FarmingTablet.windows[FarmingTablet.windows[windowName].drawFirst].drawFirst ~= nil then
						FarmingTablet.windows[FarmingTablet.windows[FarmingTablet.windows[windowName].drawFirst].drawFirst].doDraw();
						FarmingTablet.windows[FarmingTablet.windows[FarmingTablet.windows[windowName].drawFirst].drawFirst].drawed = true;
					end;
					FarmingTablet.windows[FarmingTablet.windows[windowName].drawFirst].doDraw();
					FarmingTablet.windows[FarmingTablet.windows[windowName].drawFirst].drawed = true;
				end;
				FarmingTablet.windows[windowName].drawed = true;
				FarmingTablet.windows[windowName].doDraw();
				showDetails = FarmingTablet.windows[windowName].showDetails;
			end;
		end;
		for n,_ in pairs(FarmingTablet.windows) do
			FarmingTablet.windows[n].drawed = false;
		end;
		
		if FarmingTablet.windows["Tablet_home"].active or showDetails then --or is activate by App
			setTextColor(1,1,1,1)
			renderText(0.87, 0.838, 0.027, tostring(FarmingTablet.settings.uhr1..":"..FarmingTablet.settings.uhr2));
			if FarmingTablet.akkuFuel < 1800 then			
				renderOverlay(FarmingTablet.button.getOverlayByModus_name("image", "AKKU_red").id, 0.8, 0.824, 0.045, 0.045);
				renderOverlay(FarmingTablet.button.getOverlayByModus_name("image", "AKKU_b1").id, 0.8, 0.824, 0.045, 0.045);
			elseif FarmingTablet.akkuFuel >= 1800 and FarmingTablet.akkuFuel < 3600 then
				renderOverlay(FarmingTablet.button.getOverlayByModus_name("image", "AKKU_vis").id, 0.8, 0.824, 0.045, 0.045);
				renderOverlay(FarmingTablet.button.getOverlayByModus_name("image", "AKKU_b2").id, 0.8, 0.824, 0.045, 0.045);	
			elseif FarmingTablet.akkuFuel >= 3600 and FarmingTablet.akkuFuel < 5400 then	
				renderOverlay(FarmingTablet.button.getOverlayByModus_name("image", "AKKU_vis").id, 0.8, 0.824, 0.045, 0.045);	
				renderOverlay(FarmingTablet.button.getOverlayByModus_name("image", "AKKU_b3").id, 0.8, 0.824, 0.045, 0.045);	
			elseif FarmingTablet.akkuFuel >= 5400 and FarmingTablet.akkuFuel <= 7200 then	
				renderOverlay(FarmingTablet.button.getOverlayByModus_name("image", "AKKU_vis").id, 0.8, 0.824, 0.045, 0.045);	
				renderOverlay(FarmingTablet.button.getOverlayByModus_name("image", "AKKU_b4").id, 0.8, 0.824, 0.045, 0.045);
			end;
			renderText(0.742, 0.838, 0.025, tostring(string.format("%.f", FarmingTablet.akkuFuel/72))..tostring("%"));
		end;
		renderOverlay(FarmingTablet.button.getOverlayByModus_name("image", "tabletRahmen").id,0.02,0.02,0.96,0.96);
	else
		if FarmingTablet.akkuFuel > 1 and table.getn(FarmingTablet.notifications.notificationsNoAkku) == 0 then
			if table.getn(FarmingTablet.notifications.notifications) > 0 and FarmingTablet.notifications.showPopup then
				if FarmingTablet.notifications.notifications[1].noTimeOut then
					FarmingTablet.notifications.notifications[1].timeToShow = FarmingTablet.notifications.notifications[1].timeToShow + 1;
				end;
				if FarmingTablet.notifications.notifications[1].timeToShow <= 0 then
					table.remove(FarmingTablet.notifications.notifications, 1);
					FarmingTablet.notifications.showPopupNow = false;
				end;
				if table.getn(FarmingTablet.notifications.notifications) > 0 then
					FarmingTablet:renderNotification(FarmingTablet.notifications.notifications[1]);		
					FarmingTablet.notifications.notifications[1].timeToShow = FarmingTablet.notifications.notifications[1].timeToShow - 1;			
				end;
			end;
		else
			if table.getn(FarmingTablet.notifications.notificationsNoAkku) > 0 and FarmingTablet.notifications.showPopup then
				if FarmingTablet.notifications.notificationsNoAkku[1].noTimeOut then
					FarmingTablet.notifications.notificationsNoAkku[1].timeToShow = FarmingTablet.notifications.notificationsNoAkku[1].timeToShow + 1;
				end;
				if FarmingTablet.notifications.notificationsNoAkku[1].timeToShow <= 0 then
					table.remove(FarmingTablet.notifications.notificationsNoAkku, 1);
				end;
				if table.getn(FarmingTablet.notifications.notificationsNoAkku) > 0 then
					FarmingTablet:renderNotification(FarmingTablet.notifications.notificationsNoAkku[1]);				
					FarmingTablet.notifications.notificationsNoAkku[1].timeToShow = FarmingTablet.notifications.notificationsNoAkku[1].timeToShow - 1;		
				end;
			end;
		end;
	end;		
end;

function FarmingTablet:renderNotification(notification)
	if notification.update ~= nil then
		notification.update(notification);
	end;
	setTextColor(1,1,1,1)					
	renderOverlay(FarmingTablet.button.getOverlayByModus_name("image", "notificationPopup").id, 0.8, 0.65, 0.18, 0.15);
	renderText(0.8 + 0.009, 0.775, 0.017, FarmingTablet.utils.getTextByAppName("tabletMain","titel_notification"));
	setTextBold(true);
	renderText(0.8 + 0.02, 0.742, 0.016, notification.nameApp);
	setTextBold(false);
	renderText(0.8 + 0.01, 0.71, 0.014, notification.line1);
	renderText(0.8 + 0.01, 0.68, 0.014, notification.line2);
	setTextColor(0,0,0,1)
end;

function FarmingTablet:deleteMap() end;
function FarmingTablet:delete() end;

function FarmingTablet.allAppsClose(window)
	for windowName,_ in pairs(FarmingTablet.windows) do
		FarmingTablet.windows[windowName].active = false;
	end;
	if window then
		FarmingTablet.windows[window].active = true;
	end;	
	if FarmingTablet.openWindow[window] ~= nil then
		FarmingTablet.openWindow[window]();
	end;
end;

function FarmingTablet.addNotification(nameApp, line1, line2, timeToShow, noTimeOut, update, data)
	local notification = {};
	notification.nameApp = nameApp;
	notification.line1 = line1;
	notification.line2 = line2;
	notification.timeToShow = Utils.getNoNil(timeToShow, FarmingTablet.notifications.popup_timeToShow);
	notification.noTimeOut = noTimeOut or false;
	notification.id = table.getn(FarmingTablet.notifications.notifications) + 1;
	notification.update = update;
	notification.data = data;
	table.insert(FarmingTablet.notifications.notifications, notification);
	return notification.id;
end;

function FarmingTablet.addNotificationNoAkku(nameApp, line1, line2, timeToShow, noTimeOut, update, data)
	local alredyRegister = false;
	for _,noti in pairs(FarmingTablet.notifications.notificationsNoAkku) do
		if noti.line1 == line1 then
			alredyRegister = true
		end;
	end;
	if not alredyRegister then
		local notification = {};
		notification.nameApp = nameApp;
		notification.line1 = line1;
		notification.line2 = line2;
		notification.timeToShow = Utils.getNoNil(timeToShow, FarmingTablet.notifications.popup_timeToShow);
		notification.noTimeOut = Utils.getNoNil(noTimeOut, false);
		notification.id = table.getn(FarmingTablet.notifications.notificationsNoAkku) + 1;
		notification.update = update;
		notification.data = data;
		table.insert(FarmingTablet.notifications.notificationsNoAkku, notification);
		return notification.id;
	end;
end;

function FarmingTablet:draw_Tablet_home() 
	renderOverlay(FarmingTablet.button.getOverlayByModus_Id("home", FarmingTablet.activeOverlay).id,0.005,0.0163,1,0.964);
	
	setTextColor(1,1,1,1);
	renderText(0.151, 0.792, 0.026, FarmingTablet.categorys[1]);
	renderText(0.41, 0.792, 0.026, FarmingTablet.categorys[2]);
	renderText(0.66, 0.792, 0.026, FarmingTablet.categorys[3]);
	setTextColor(0,0,0,1);
	
	FarmingTablet.button.drawButtonByCategory("START_PAGE");	
	for name,_ in pairs(FarmingTablet.apps_toDraw) do
		local category = FarmingTablet.apps[name].appCategoryDefault;
		local place = FarmingTablet.apps[name].posUsed;
		local x,y,xS,yS = FarmingTablet.apps_positions[category][place][1],FarmingTablet.apps_positions[category][place][2],FarmingTablet.apps_positions[category][place][3],FarmingTablet.apps_positions[category][place][4]
		renderOverlay(FarmingTablet.apps[name].iconImage,x,y,xS,yS);
	end;
end;

function FarmingTablet:draw_Tablet_notifications() 
	renderOverlay(FarmingTablet.button.getOverlayByModus_Id("home", FarmingTablet.activeOverlay).id,0.005,0.0163,1,0.964);
	renderOverlay(FarmingTablet.button.getOverlayByModus_name("image", "SCREEN_GreyAlpha").id, 0.005,0.0163,1,0.964);
	
	setTextColor(0,0,0,1)
	setTextBold(true)
	renderText(0.086,0.79,0.028,FarmingTablet.utils.getTextByAppName("tabletMain","notifications"));
	
	local numNot = table.getn(FarmingTablet.notifications.notifications)
	
	if numNot == 0 then
		local x = 0.5 - getTextWidth(0.03, FarmingTablet.utils.getTextByAppName("tabletMain","notifications_noNotifictaion")) / 2;
		setTextColor(0,0,0,1);
		renderText(x, 0.5, 0.03, FarmingTablet.utils.getTextByAppName("tabletMain","notifications_noNotifictaion"))
	else
		for i = 1, numNot do
			if i % 2 == 1 then
				renderOverlay(FarmingTablet.button.getOverlayByModus_name("image", "background02").id, 0.1, 0.72 - ((i - 1) * 0.04), 0.65, 0.04);
			else
				renderOverlay(FarmingTablet.button.getOverlayByModus_name("image", "background03").id, 0.1, 0.72 - ((i - 1) * 0.04), 0.65, 0.04);
			end;
		end;
	end;
end;

function FarmingTablet:draw_Tablet_settings() 
	renderOverlay(FarmingTablet.button.getOverlayByModus_Id("home", FarmingTablet.activeOverlay).id,0.005,0.0163,1,0.964);
	renderOverlay(FarmingTablet.button.getOverlayByModus_name("image", "SCREEN_GreyAlpha").id, 0.005,0.0163,1,0.964);
	FarmingTablet.button.drawButtonByCategory("SETTINGS_PAGE");
end;

function FarmingTablet:update_Tablet_settings1()
	g_farmingTablet.setWindow("Tablet_settings",true);
end;
function FarmingTablet.key_Tablet_settings1(unicode, sym, modifier, isDown)
	local activeField = 0;
	for i=1, 3 do 
		local btn = g_farmingTablet.button.getButtonByApp("tabletMain", "btn_field_category" .. tostring(i));
		if btn.ActivateState then
			activeField = i;
		end;
	end;
	
	if activeField ~= 0 and isDown then
		if sym == 13 then
			g_farmingTablet.button.getButtonByApp("tabletMain", "btn_field_category" .. tostring(activeField)).ActivateState = false;
		elseif sym == 8 then
			FarmingTablet.categorys[activeField] = FarmingTablet.categorys[activeField]:sub(1, FarmingTablet.categorys[activeField]:len()-1);
		elseif getCanRenderUnicode(unicode) then
			FarmingTablet.categorys[activeField] = FarmingTablet.categorys[activeField] .. unicodeToUtf8(unicode);
		end;
	end;	
end;
function FarmingTablet:draw_Tablet_settings1()
	setTextBold(true)
	setTextColor(1,1,1,1)
	renderText(0.086,0.79,0.028,FarmingTablet.utils.getTextByAppName("tabletMain","settings") .. " - " .. FarmingTablet.utils.getTextByAppName("tabletMain","btn_Settings_General"));
	setTextBold(false)
	
	setTextColor(g_farmingTablet.utils.getActiveTextColor())	
	renderText(0.2,0.63,0.025,FarmingTablet.utils.getTextByAppName("tabletMain","_btn_tick_notificationsPopup"));
	renderText(0.2,0.56,0.025,FarmingTablet.utils.getTextByAppName("tabletMain","_btn_tick_activeAkkuUsage"));
	
	renderText(0.14,0.49,0.025,FarmingTablet.utils.getTextByAppName("tabletMain","_btn_field_category1"));
	renderText(0.14,0.42,0.025,FarmingTablet.utils.getTextByAppName("tabletMain","_btn_field_category2"));
	renderText(0.14,0.35,0.025,FarmingTablet.utils.getTextByAppName("tabletMain","_btn_field_category3"));	
	setTextColor(0,0,0,1)
	renderText(0.258,0.49,0.025, FarmingTablet.categorys[1]);
	renderText(0.258,0.42,0.025, FarmingTablet.categorys[2]);
	renderText(0.258,0.35,0.025, FarmingTablet.categorys[3]);
	setTextColor(g_farmingTablet.utils.getActiveTextColor())
	
	FarmingTablet.button.drawButtonByCategory("SETTINGS_PAGE1");
end;

function FarmingTablet:update_Tablet_settings2()
	g_farmingTablet.setWindow("Tablet_settings",true);
end;
function FarmingTablet:draw_Tablet_settings2()
	setTextBold(true)
	setTextColor(1,1,1,1)
	renderText(0.086,0.79,0.028,FarmingTablet.utils.getTextByAppName("tabletMain","settings") .. " - " .. FarmingTablet.utils.getTextByAppName("tabletMain","btn_Settings_Design"));
	setTextBold(false)
	
	setTextColor(g_farmingTablet.utils.getActiveTextColor())
	renderText(0.14,0.63,0.025,FarmingTablet.utils.getTextByAppName("tabletMain","Head_colorChoose"));
	setTextAlignment(RenderText.ALIGN_CENTER)
	renderText(0.5575,0.63,0.025,FarmingTablet.button.getOverlayByModus_Id("home",FarmingTablet.activeOverlay).text);
	setTextAlignment(RenderText.ALIGN_LEFT)
	
	renderText(0.2,0.53,0.025,FarmingTablet.utils.getTextByAppName("tabletMain","_btn_tick_useOwnTextColor"));
	renderText(0.14,0.46,0.025,FarmingTablet.utils.getTextByAppName("tabletMain","Head_textColorChoose"));
	renderText(0.14,0.39,0.025,FarmingTablet.utils.getTextByAppName("tabletMain","_slideBar_r"));
	renderText(0.34,0.39,0.025,FarmingTablet.utils.getTextByAppName("tabletMain","_slideBar_g"));
	renderText(0.54,0.39,0.025,FarmingTablet.utils.getTextByAppName("tabletMain","_slideBar_b"));
	renderText(0.74,0.39,0.025,FarmingTablet.utils.getTextByAppName("tabletMain","_slideBar_a"));
	
	local r = FarmingTabletButton.getSlidebarByCategoryName("SETTINGS_PAGE2", "slideBar_settings_r").stateWidth;
	local g = FarmingTabletButton.getSlidebarByCategoryName("SETTINGS_PAGE2", "slideBar_settings_g").stateWidth;
	local b = FarmingTabletButton.getSlidebarByCategoryName("SETTINGS_PAGE2", "slideBar_settings_b").stateWidth;
	local a = FarmingTabletButton.getSlidebarByCategoryName("SETTINGS_PAGE2", "slideBar_settings_a").stateWidth;
    setOverlayColor(FarmingTablet.button.getOverlayByModus_name("image", "SCREEN_TextColor").id, r,g,b,a);
	renderOverlay(FarmingTablet.button.getOverlayByModus_name("image", "SCREEN_TextColor").id, 0.33, 0.44, 0.1, 0.06);	

	FarmingTablet.button.drawButtonByCategory("SETTINGS_PAGE2");
end;

function FarmingTablet:update_Tablet_settings3()
	g_farmingTablet.setWindow("Tablet_settings",true);
end;
function FarmingTablet:draw_Tablet_settings3()
	setTextBold(true)
	setTextColor(1,1,1,1)
	renderText(0.086,0.79,0.028,FarmingTablet.utils.getTextByAppName("tabletMain","settings") .. " - " .. FarmingTablet.utils.getTextByAppName("tabletMain","btn_Settings_Apps"));
	setTextBold(false)
	
	g_farmingTablet.button.getButtonByApp("tabletMain", "backgroundAppLower").visible = false;
	g_farmingTablet.button.getButtonByApp("tabletMain", "backgroundAppHigher").visible = false;
	g_farmingTablet.button.getButtonByApp("tabletMain", "btn_tick_useOwnTextColor2").visible = false;
	g_farmingTablet.button.getSlidebarByCategoryName("SETTINGS_PAGE3", "slideBar_settings3_r").visible = false;
	g_farmingTablet.button.getSlidebarByCategoryName("SETTINGS_PAGE3", "slideBar_settings3_g").visible = false;
	g_farmingTablet.button.getSlidebarByCategoryName("SETTINGS_PAGE3", "slideBar_settings3_b").visible = false;
	g_farmingTablet.button.getSlidebarByCategoryName("SETTINGS_PAGE3", "slideBar_settings3_a").visible = false;
	
	local visibleButtons = true;
	setTextColor(g_farmingTablet.utils.getActiveTextColor())
	
	local app = FarmingTablet.getAppById[FarmingTablet.settings.activeAppChoose];
	if app ~= nil then
		renderText(0.14,0.63,0.025,FarmingTablet.utils.getTextByAppName("tabletMain","Head_app"));
		setTextAlignment(RenderText.ALIGN_CENTER)
		renderText(0.4675,0.63,0.025,app.nameOfApp);
		setTextAlignment(RenderText.ALIGN_LEFT)
		
		if FarmingTablet.apps_useSettings[FarmingTablet.settings.activeAppChoose] then		
			g_farmingTablet.button.getButtonByApp("tabletMain", "backgroundAppLower").visible = true;
			g_farmingTablet.button.getButtonByApp("tabletMain", "backgroundAppHigher").visible = true;
			g_farmingTablet.button.getButtonByApp("tabletMain", "btn_tick_useOwnTextColor2").visible = true;
			g_farmingTablet.button.getSlidebarByCategoryName("SETTINGS_PAGE3", "slideBar_settings3_r").visible = true;
			g_farmingTablet.button.getSlidebarByCategoryName("SETTINGS_PAGE3", "slideBar_settings3_g").visible = true;
			g_farmingTablet.button.getSlidebarByCategoryName("SETTINGS_PAGE3", "slideBar_settings3_b").visible = true;
			g_farmingTablet.button.getSlidebarByCategoryName("SETTINGS_PAGE3", "slideBar_settings3_a").visible = true;
			renderText(0.14,0.53,0.025,FarmingTablet.utils.getTextByAppName("tabletMain","Head_colorChoose2"));
			renderText(0.47,0.53,0.025,FarmingTablet.button.getOverlayByModus_Id("app", app.backgroundActiveIndex).text);
			renderOverlay(FarmingTablet.button.getOverlayByModus_Id("app", app.backgroundActiveIndex).id,0.36,0.51,0.1,0.066);
					
			renderText(0.2,0.34,0.025,FarmingTablet.utils.getTextByAppName("tabletMain","_btn_tick_useOwnTextColor"));
			renderText(0.14,0.27,0.025,FarmingTablet.utils.getTextByAppName("tabletMain","Head_textColorChoose"));
			renderText(0.14,0.2,0.025,FarmingTablet.utils.getTextByAppName("tabletMain","_slideBar_r"));
			renderText(0.34,0.2,0.025,FarmingTablet.utils.getTextByAppName("tabletMain","_slideBar_g"));
			renderText(0.54,0.2,0.025,FarmingTablet.utils.getTextByAppName("tabletMain","_slideBar_b"));
			renderText(0.74,0.2,0.025,FarmingTablet.utils.getTextByAppName("tabletMain","_slideBar_a"));
			
			local r = FarmingTabletButton.getSlidebarByCategoryName("SETTINGS_PAGE3", "slideBar_settings3_r").stateWidth;
			local g = FarmingTabletButton.getSlidebarByCategoryName("SETTINGS_PAGE3", "slideBar_settings3_g").stateWidth;
			local b = FarmingTabletButton.getSlidebarByCategoryName("SETTINGS_PAGE3", "slideBar_settings3_b").stateWidth;
			local a = FarmingTabletButton.getSlidebarByCategoryName("SETTINGS_PAGE3", "slideBar_settings3_a").stateWidth;
			setOverlayColor(FarmingTablet.button.getOverlayByModus_name("image", "SCREEN_TextColor").id, r,g,b,a);
			renderOverlay(FarmingTablet.button.getOverlayByModus_name("image", "SCREEN_TextColor").id, 0.33, 0.25, 0.1, 0.06);		
			visibleButtons = true;
		end;
		
		renderText(0.14,0.43,0.025,FarmingTablet.utils.getTextByAppName("tabletMain","_btn_category"));
		local x = 0.468 - getTextWidth(0.025, FarmingTablet.categorys[app.appCategoryDefault])/2;
		renderText(x,0.43,0.025,FarmingTablet.categorys[app.appCategoryDefault]);
	end;	
	
	g_farmingTablet.button.getButtonByApp("tabletMain", "chooseAppLower").visible = visibleButtons;
	g_farmingTablet.button.getButtonByApp("tabletMain", "chooseAppHigher").visible = visibleButtons;
	FarmingTablet.button.drawButtonByCategory("SETTINGS_PAGE3");
end;

g_careerScreen.saveSavegame = Utils.appendedFunction(g_careerScreen.saveSavegame, FarmingTablet.saveMapXML);
g_gui.showGui = FarmingTablet.setGuiClose(g_gui.showGui);