-- 
-- FarmingTablet - Button
-- 
-- @Interface: 1.4.4.0 1.4.4RC8
-- @Author: kevink98 
-- @Date: 25.09.2017
-- @Version: 1.2.0
-- 
-- @Support: http://ls-modcompany.com
-- @mCompanyInfo: http://mcompany-info.de/
-- 

FarmingTabletButton = {};
g_farmingTablet.button = FarmingTabletButton;
FarmingTabletButton.allButtons = {};
FarmingTabletButton.allSlider = {};
FarmingTabletButton.allSliderCategory = {};
FarmingTabletButton.buttonsByApp = {};
FarmingTabletButton.categorys = {};
FarmingTabletButton.allOverlays = {};
FarmingTabletButton.overlayByModus = {[1]={},[2]={},[3]={},[4]={}};

FarmingTabletButton.MODUS = {};
FarmingTabletButton.MODUS["home"] = 1; 
FarmingTabletButton.MODUS["app"] = 2; 
FarmingTabletButton.MODUS["image"] = 3; 
FarmingTabletButton.MODUS["button"] = 4; 

FarmingTabletButton.version = "1.1.0";
print("   [FarmingTablet - Button] load " .. tostring(FarmingTabletButton.version));

source(g_currentModDirectory.."ButtonActions.lua");

function FarmingTabletButton.newButton(app, appname, name,category,x,y,xS,yS,hoverT,defaultT,activeT,useOwnFunc, visible, activateState, funcName, para, textHeight, c1, c2,d, activated, appNameButtonText)
	local button = {};
	button.hover = false;
	button.name = name;
	button.visible = Utils.getNoNil(visible, true);
	button.isActivated = Utils.getNoNil(activated, true);
	button.autoDrawText = true;
	if appNameButtonText == nil then
		appNameButtonText = appname;
	end;
	local text, hasText = g_farmingTablet.utils.getTextByAppName(appNameButtonText, name);
	if hasText then
		button.text = text;
	end;
	button.textHeight = textHeight or 0.028;
	button.textColorHover = c1;
	button.textColor = c2;
	button.distance = d;
	
	if useOwnFunc then
		local nameHover = "onActiveHover"..name;
		local nameHoverDe = "onDeactiveHover"..name;
		button.onActiveHover = function(...) return ButtonActions[nameHover](...) end;
		button.onDeactiveHover = function(...) return ButtonActions[nameHoverDe](...) end;
	else
		button.onActiveHover = function(name) return FarmingTabletButton:onActiveHover(button) end;
		button.onDeactiveHover = function(name) return FarmingTabletButton:onDeactiveHover(button) end;
	end;
	
	if appname == "tabletMain" then
		if funcName ~= nil then
			button.onActiveClick = function(...) 
				button.hover = false;
				return ButtonActions[funcName](b,button,para,...) 
			end;
		else
			local nameClick = "onActiveClick"..name;
			button.onActiveClick = function(...) 
				button.hover = false;
				return ButtonActions[nameClick](b,button,para,...) 
			end;
		end;
	else
		if funcName ~= nil then
			button.onActiveClick = function(...) 
				button.hover = false;
				return app[funcName](b,button,para,...) 
			end;
		else
			local nameClick = "onActiveClick_"..name;
			button.onActiveClick = function(...) 
				button.hover = false;
				return app[nameClick](b,button,para,...) 
			end;
		end;
	end;
	
	button.posXL = x;
	button.posYU = y;
	button.posXR = x+xS;
	button.posYO = y+yS;
	button.scaleX = xS;
	button.scaleY = yS;
	
	button.OverlayHover = hoverT or defaultT;
	button.OverlayDefault = defaultT;
	button.OverlayActivate = activeT;
	button.ActivateState = Utils.getNoNil(activateState, false);
	button.textBold = button.ActivateState;
	if (hoverT == nil and defaultT == nil) or (hoverT == nil and defaultT ~= nil and activeT ~= nil) or (hoverT ~= nil and defaultT ~= nil and activeT ~= nil) then
		button.noDrawButton = true;
	else
		button.noDrawButton = false;
	end;
	
	if FarmingTabletButton.categorys[category] ~= nil then
		table.insert(FarmingTabletButton.categorys[category],button);
	else
		print("Error: Failed to add Button: "..name);
		return
	end;
	table.insert(FarmingTabletButton.allButtons,button);
	if FarmingTabletButton.buttonsByApp[appname] == nil then
		FarmingTabletButton.buttonsByApp[appname] = {};
	end;
	table.insert(FarmingTabletButton.buttonsByApp[appname], button);
	return button;
end;

function FarmingTabletButton.newSlideBar(app, appName, name, category,x,y,xS,yS,s_x,s_y,vS,vE,background, sliderDefault, sliderHover, funcSet, useSliderSize)
	local slider = {};
	slider.hover = false;
	slider.name = name;
	slider.visible = true;
	slider.posXL = x;
	slider.posYU = y;
	slider.posXR = x+xS;
	slider.posYO = y+yS;
	slider.scaleX = xS;
	slider.scaleY = yS;
	slider.sliderWidth = s_x;
	slider.sliderHeight = s_y;
	slider.minValue = vS;
	slider.maxValue = vE;
	slider.background = background;
	slider.sliderDefault = sliderDefault;
	slider.sliderHover = sliderHover or sliderDefault;
	slider.stateWidth = 0;
	slider.stateHeight = 0;
	slider.oldPosWidth = slider.posXL + (slider.sliderWidth / 2);
	slider.oldPosHeigth = slider.posXL + (slider.sliderHeight / 2);
	slider.isActive = false;
	
	slider.useSliderSize = useSliderSize;
	
	if appName == "tabletMain" then
		local nameClick = "onActiveClick_"..name;
		slider.onActiveClick = function(...)
			slider.hover = false;
			return ButtonActions[nameClick](b, slider,...);
		end;
		if funcSet ~= nil then
			slider.funcSet = function(...)
				return ButtonActions[funcSet](b, slider,...);
			end;
		end;
	else
		local nameClick = "onActiveClick_"..name;
		slider.onActiveClick = function(...)
			slider.hover = false;
			return app[nameClick](b, slider,...);
		end;
		if funcSet ~= nil then
			slider.funcSet = function(...)
				return app[funcSet](b, slider,...);
			end;
		end;
	end;
	
	table.insert(FarmingTabletButton.allSlider, slider);
	if FarmingTabletButton.allSliderCategory[category] == nil then
		FarmingTabletButton.allSliderCategory[category] = {};
	end;
	table.insert(FarmingTabletButton.allSliderCategory[category], slider);	
end;	

function FarmingTabletButton.newCategory(nameCategory)
	if FarmingTabletButton.categorys[nameCategory] == nil then
		FarmingTabletButton.categorys[nameCategory] = {};
	end;
end;

function FarmingTabletButton.addOverlays(overlays,nameO)
	for _, overlay in pairs(overlays) do
		if FarmingTabletButton.allOverlays[overlay.name] ~= nil then
			print("FarmingTablet: Overlay " .. overlay.name .. " already exists!");
		else
			FarmingTabletButton.allOverlays[overlay.name] = overlay;
			table.insert(FarmingTabletButton.overlayByModus[FarmingTabletButton.MODUS[overlay.modus]], overlay);
		end;
	end;
end;

function FarmingTabletButton.getOverlay(name)
	return FarmingTabletButton.allOverlays[name]
end;

function FarmingTabletButton.getOverlayByModus_Id(modus, id)
	return FarmingTabletButton.overlayByModus[FarmingTabletButton.MODUS[modus]][id]
end;

function FarmingTabletButton.getOverlayByModus_name(modus, name)
	for _, overlay in pairs(FarmingTabletButton.overlayByModus[FarmingTabletButton.MODUS[modus]]) do
		if overlay.name == name then
			return overlay;
		end;
	end;
end;

function FarmingTabletButton.getOverlayTextByModus_name(modus, name)
	for _, overlay in pairs(FarmingTabletButton.overlayByModus[modus]) do
		if overlay.name == name then
			return overlay.text;
		end;
	end;
end;

function FarmingTabletButton.getButtonByApp(app, name)
	for _, button in pairs(FarmingTabletButton.buttonsByApp[app]) do
		if button.name == name then
			return button;
		end;
	end;
end;

function FarmingTabletButton.getButtonByCategoryName(category, name)
	for _, button in pairs(FarmingTabletButton.categorys[category]) do
		if button.name == name then
			return button;
		end;
	end;
end;

function FarmingTabletButton.getSlidebarByCategoryName(category, name)
	for _, slider in pairs(FarmingTabletButton.allSliderCategory[category]) do
		if slider.name == name then
			return slider;
		end;
	end;
end;

function FarmingTabletButton.drawButtonByCategory(categoryName)
	for _,button in pairs(FarmingTabletButton.categorys[categoryName]) do
		if button.visible then
			if not button.noDrawButton then
				if button.hover and FarmingTabletButton.allOverlays[button.OverlayHover] ~= nil then
					renderOverlay(FarmingTabletButton.allOverlays[button.OverlayHover].id, button.posXL,button.posYU,button.scaleX,button.scaleY);
				elseif FarmingTabletButton.allOverlays[button.OverlayDefault] ~= nil then
					renderOverlay(FarmingTabletButton.allOverlays[button.OverlayDefault].id, button.posXL,button.posYU,button.scaleX,button.scaleY);
				elseif button.ActivateState and FarmingTabletButton.allOverlays[button.OverlayActivate] ~= nil then
					renderOverlay(FarmingTabletButton.allOverlays[button.OverlayActivate].id, button.posXL,button.posYU,button.scaleX,button.scaleY);
				end;
			elseif button.OverlayActivate and button.OverlayHover == nil then
				if button.ActivateState then
					renderOverlay(FarmingTabletButton.allOverlays[button.OverlayActivate].id, button.posXL,button.posYU,button.scaleX,button.scaleY);
				elseif FarmingTabletButton.allOverlays[button.OverlayDefault] ~= nil then
					renderOverlay(FarmingTabletButton.allOverlays[button.OverlayDefault].id, button.posXL,button.posYU,button.scaleX,button.scaleY);
				end;
			elseif button.OverlayActivate and button.OverlayHover ~= nil then
				if button.hover and FarmingTabletButton.allOverlays[button.OverlayHover] ~= nil then
					renderOverlay(FarmingTabletButton.allOverlays[button.OverlayHover].id, button.posXL,button.posYU,button.scaleX,button.scaleY);
				end;
				if button.ActivateState then
					renderOverlay(FarmingTabletButton.allOverlays[button.OverlayActivate].id, button.posXL,button.posYU,button.scaleX,button.scaleY);
				elseif FarmingTabletButton.allOverlays[button.OverlayDefault] ~= nil and not button.hover then
					renderOverlay(FarmingTabletButton.allOverlays[button.OverlayDefault].id, button.posXL,button.posYU,button.scaleX,button.scaleY);
				end;
			end;
			if button.text ~= nil and button.autoDrawText then
				g_farmingTablet.utils.drawTextButton(button, button.text, button.textHeight, button.distance, button.textColorHover, button.textColor, button.textBold);
			end;
		end;
	end;
	FarmingTabletButton.drawSliderByCategory(categoryName)
end;

function FarmingTabletButton.drawSliderByCategory(category)
	if FarmingTabletButton.allSliderCategory[category] ~= nil then
		for _, slider in pairs(FarmingTabletButton.allSliderCategory[category]) do
			if slider.visible then
				if FarmingTabletButton.allOverlays[slider.background] and FarmingTabletButton.allOverlays[slider.background].id ~= nil then
					renderOverlay(FarmingTabletButton.allOverlays[slider.background].id, slider.posXL, slider.posYU, slider.scaleX, slider.scaleY);
				end;
				local x,y = 0,0;
				if slider.useSliderSize then
					x = slider.posXL + ((slider.posXR - slider.posXL - slider.sliderWidth) / slider.maxValue * slider.stateWidth);
					y = slider.posYU + ((slider.posYO - slider.posYU - slider.sliderHeight) / slider.maxValue * slider.stateHeight);		
				else
					x = slider.posXL + ((slider.posXR - slider.posXL) / slider.maxValue * slider.stateWidth) - (slider.sliderWidth/2);
					y = slider.posYU + ((slider.posYO - slider.posYU) / slider.maxValue * slider.stateHeight);	
				end;
				if slider.hover then
					renderOverlay(FarmingTabletButton.allOverlays[slider.sliderHover].id, x, y, slider.sliderWidth, slider.sliderHeight);
				else
					renderOverlay(FarmingTabletButton.allOverlays[slider.sliderDefault].id, x, y, slider.sliderWidth, slider.sliderHeight);
				end;
			end;
		end;
	end;
end;

function FarmingTabletButton:checkClickByCategory(categoryName,posX,posY,buttonIsClick,isDown)
	if FarmingTabletButton.categorys[categoryName] ~= nil then
		local isClicked = false
		for _,button in pairs (FarmingTabletButton.categorys[categoryName]) do
			if posX > button.posXL and posX < button.posXR and posY > button.posYU and posY < button.posYO and buttonIsClick == 1 and isDown and button.visible and button.isActivated then
				button.onActiveClick(button);
				return true;
			end;
		end;
	end;
end;	

function FarmingTabletButton:checkSlideBarByCategory(categoryName,posX,posY,buttonIsClick,isDown,isUp)
	if FarmingTabletButton.allSliderCategory[categoryName] ~= nil then
		for _,slider in pairs(FarmingTabletButton.allSliderCategory[categoryName]) do
			local xL,yU = 0,0;
			if slider.useSliderSize then
				xL = slider.posXL + ((slider.posXR - slider.posXL - slider.sliderWidth) / slider.maxValue * slider.stateWidth);		
				yU = slider.posYU + ((slider.posYO - slider.posYU - slider.sliderHeight) / slider.maxValue * slider.stateHeight);
			else
				xL = slider.posXL + ((slider.posXR - slider.posXL) / slider.maxValue * slider.stateWidth) - (slider.sliderWidth/2);	
				yU = slider.posYU + ((slider.posYO - slider.posYU) / slider.maxValue * slider.stateHeight);
			end;
			local xR = xL + slider.sliderWidth;
			local yO = yU + slider.sliderHeight;
			if buttonIsClick == 1 and isDown  and posX > xL and posX < xR and posY > yU and posY < yO and slider.visible then
				slider.isActive = true;
			elseif buttonIsClick == 1 and isUp then
				slider.isActive = false;
				slider.oldPosWidth = 0
				slider.oldPosHeigth = 0
			end;
			if slider.isActive then
				if slider.oldPosWidth == 0 then
					slider.oldPosWidth = posX
					slider.oldPosHeigth = posY
				else
					local dif =  posX - slider.oldPosWidth;
					local dif2 = posY - slider.oldPosHeigth;
					
					slider.stateWidth = slider.stateWidth + (((slider.maxValue-slider.minValue)/((slider.posXR-slider.posXL)/dif)))
					slider.stateHeight = slider.stateHeight + (((slider.maxValue-slider.minValue)/((slider.posYO-slider.posYU)/ dif2)))
					
					if slider.stateWidth > slider.maxValue then
						slider.stateWidth = slider.maxValue;
					elseif slider.stateWidth < slider.minValue then
						slider.stateWidth = slider.minValue;
					end;
					if slider.stateHeight > slider.maxValue then
						slider.stateHeight = slider.maxValue;
					elseif slider.stateHeight < slider.minValue then
						slider.stateHeight = slider.minValue;
					end;
					slider.oldPosWidth = posX;
					slider.oldPosHeigth = posY;
					if slider.funcSet ~= nil then
						slider.funcSet();
					end;
				end;
			end;
		end;
	end;
end;

function FarmingTabletButton:checkHoverByCategory(categoryName,posX,posY)
	for _,button in pairs (FarmingTabletButton.categorys[categoryName]) do
		if posX > button.posXL and posX < button.posXR and posY > button.posYU and posY < button.posYO and button.visible and button.isActivated then
			button.onActiveHover(button);
		elseif button.isActivated then
			button.onDeactiveHover(button);
		end;
	end;
	if FarmingTabletButton.allSliderCategory[categoryName] ~= nil then
		for _, slider in pairs(FarmingTabletButton.allSliderCategory[categoryName]) do		
			local xL,yU  = 0,0;
			if slider.useSliderSize then
				xL = slider.posXL + ((slider.posXR - slider.posXL - slider.sliderWidth) / slider.maxValue * slider.stateWidth);		
				yU = slider.posYU + ((slider.posYO - slider.posYU - slider.sliderHeight) / slider.maxValue * slider.stateHeight);
			else
				xL = slider.posXL + ((slider.posXR - slider.posXL) / slider.maxValue * slider.stateWidth) - (slider.sliderWidth/2);	
				yU = slider.posYU + ((slider.posYO - slider.posYU) / slider.maxValue * slider.stateHeight);
			end;
			local xR = xL + slider.sliderWidth;
			local yO = yU + slider.sliderHeight;	
			if (posX > xL and posX < xR and posY > yU and posY < yO and slider.visible) or slider.isActive then
				slider.hover = true;
			else
				slider.hover = false;
			end;
		end;
	end;
end;

function FarmingTabletButton:checkAppClick(posX,posY,buttonIsClick,isDown,positions,windowToOpen,name)
	if posX > positions.xL and posX < positions.xR and posY > positions.yU and posY < positions.yO and buttonIsClick == 1 and isDown then
		if FarmingTablet.openApp[windowToOpen] ~= nil then
			FarmingTablet.openApp[windowToOpen]();
		end;
		FarmingTablet.allAppsClose(windowToOpen);
		FarmingTablet.activeAppName = name;
	end;
end;

function FarmingTabletButton:onActiveHover(button) 
	button.hover = true;
end;

function FarmingTabletButton:onDeactiveHover(button) 
	button.hover = false;
end;